<?php

$plugin_info = array(
										 'pi_name'			   => 'CSVGrab',
										 'pi_version'		   => '0.2.3',
										 'pi_author'			 => 'Andrew Weaver',
										 'pi_author_url'	 => 'http://www.brandnewbox.co.uk/docs/',
										 'pi_description'  => 'Allows you to import data from a CVS feed and into a weblog',
										 'pi_usage'			   => CSVGrab::usage()
										 );


class CSVGrab {

	var $debug = true;
	var $runsql = true;
	var $trace = false;

	var $page_url = '';
	var $title = '';
	var $publish_date = '';
	var $author_id = '1';
	var $feed_weblog_id = '';
	var $feed_fields = '';
	var $weblog_fields = '';
	var $skip = 0;
	var $stagger = 0;
	var $cats = '';
	var $cat_group = 0;
	var $cat_field = 0;
	var $cat_delimiter = ',';
	var $unique = 'title';
	var $delimiter = '\t';
	var $encloser = '';
	var $site_id = '';
    
	var $return_data = '';
    
	var $time_offset = 0;

	function CSVGrab() {
		global $TMPL, $LOC, $FNS, $PREFS, $SESS, $REGX, $DB;
        
		// Check parameters
        
		$this->page_url = ( ! $TMPL->fetch_param('url') ) ? '' : str_replace('&#47;', '/',trim($TMPL->fetch_param('url')));
		$this->feed_weblog_id = ( ! $TMPL->fetch_param('weblog') ) ? '' : $TMPL->fetch_param('weblog');
		$this->author_id = ( ! $TMPL->fetch_param('author') ) ? 1 : $TMPL->fetch_param('author');
		$this->title = ( ! $TMPL->fetch_param('title') ) ? 0 : $TMPL->fetch_param('title');
		$this->publish_date = ( ! $TMPL->fetch_param('date') ) ? '' : $TMPL->fetch_param('date');
		$this->feed_fields = ( ! $TMPL->fetch_param('use') ) ? '' : $TMPL->fetch_param('use');
		$this->weblog_fields = ( ! $TMPL->fetch_param('fields') ) ? '' : $TMPL->fetch_param('fields');
		$this->time_offset = ( ! $TMPL->fetch_param('offset') ) ? 0 : $TMPL->fetch_param('offset');
		$this->skip = ( ! $TMPL->fetch_param('skip') ) ? 0 : $TMPL->fetch_param('skip');
		$this->stagger = ( ! $TMPL->fetch_param('stagger') ) ? 0 : $TMPL->fetch_param('stagger');
		$this->delimiter = ( ! $TMPL->fetch_param('delimiter') ) ? ',' : $TMPL->fetch_param('delimiter');
		$this->encloser = ( ! $TMPL->fetch_param('encloser') ) ? '"' : $TMPL->fetch_param('encloser');
		$this->encloser = ( $TMPL->fetch_param('encloser') == "" ) ? '' : $this->encloser;
		$this->cats = ( ! $TMPL->fetch_param('category') ) ? '' : $TMPL->fetch_param('category');
		$this->cat_group = ( ! $TMPL->fetch_param('category_group') ) ? 0 : $TMPL->fetch_param('category_group');
		$this->cat_field = ( ! $TMPL->fetch_param('category_field') ) ? 0 : $TMPL->fetch_param('category_field');
		$this->cat_delimiter = ( ! $TMPL->fetch_param('category_delimiter') ) ? ',' : $TMPL->fetch_param('category_delimiter');
		$this->unique = ( ! $TMPL->fetch_param('unique') ) ? 'title' : $TMPL->fetch_param('unique');
		$this->site_id = ( ! $TMPL->fetch_param('site_id') ) ? '' : $TMPL->fetch_param('site_id');
		$this->trace = ( ! $TMPL->fetch_param('trace') ) ? false : true;
    
		if ($this->page_url == '') {
			return $this->return_data;
		}
		if ($this->delimiter == 'TAB') {
            $this->delimiter = "\t";
		}    
		if ($this->delimiter == 'SPACE') {
            $this->delimiter = " ";
		}    
		if ($this->delimiter == 'QUOTE') {
            $this->delimiter = '"';
		}    
		if ($this->encloser == 'QUOTE') {
            $this->encloser = '"';
		}    
		if ($this->feed_weblog_id == '') {
			return $this->return_data;
		}
		if ($this->feed_fields == '') {
			return $this->return_data;
		} else {
			$fieldsArray = split( "\|", $this->feed_fields );
		}
		if ($this->weblog_fields == '') {
			return $this->return_data;
		} else {
			$weblogArray = split( "\|", $this->weblog_fields );
		}

		if ($this->cat_delimiter == 'TAB') {
            $this->cat_delimiter = "\t";
		}    
		if ($this->cat_delimiter == 'SPACE') {
            $this->cat_delimiter = " ";
		}
		
		// Check number of input and weblog fields match
		if ( count($fieldsArray) != count($weblogArray) ) {
			return $this->return_data;
		}

		$weblog_to_feed[ 'title' ] = Array();
		$weblog_to_feed[ 'title' ][ 'is_custom' ] = 0;
		$weblog_to_feed[ 'title' ][ 'field' ] = $this->title;
		$weblog_to_feed[ 'date' ] = Array();
		$weblog_to_feed[ 'date' ][ 'is_custom' ] = 0;
		$weblog_to_feed[ 'date' ][ 'field' ] = $this->publish_date;
		
		// Use fields array to map feed fields to weblog fields
		for( $i=0; $i<count( $weblogArray ); $i++ ) {
			$weblog_to_feed[ $weblogArray[ $i ] ] = Array();
			$weblog_to_feed[ $weblogArray[ $i ] ][ 'is_custom' ] = 1;
			$weblog_to_feed[ $weblogArray[ $i ] ][ 'field' ] = $fieldsArray[ $i ];
		} 
		
		// Get custom fields from database
		$customfieldsArray = $DB->query("SELECT exp_weblog_fields.field_id, 
								exp_weblog_fields.field_name, 
								exp_weblog_fields.field_label, exp_weblog_fields.field_fmt
							 	FROM exp_weblogs, exp_weblog_fields
							 	WHERE exp_weblogs.field_group = exp_weblog_fields.group_id
								AND exp_weblogs.weblog_id = '".$this->feed_weblog_id."'");
		$field_ids = '';
		
		// Map weblog custom fields to id's
		foreach ( $customfieldsArray->result as $row ) {
			$weblog_to_feed[ $row[ "field_name" ] ][ 'id' ] = $row[ "field_id" ];
			$weblog_to_feed[ $row[ "field_name" ] ][ 'format' ] = $row[ "field_fmt" ];
		}

		if ( $this->trace ) {
			print "<p>TRACE: ";
			print_r( $weblog_to_feed );
			print "</p>";
		}

		// Retrieve CVS file
        
    $row = 0;
    $offset = 0;
    
		// fopen allowed?
    if ( !ini_get('allow_url_fopen') ) {
    		// No, is it a remote file?
        if (eregi('^(http|ftp)://', substr($this->page_url, 0, 10))) {
        		// Create temporary file
	          $handle = tmpfile();
	          // Can we use curl?
        		if ( function_exists('curl_init') ) {        		
	            $ch = curl_init($this->page_url);
	            curl_setopt($ch, CURLOPT_FILE, $handle);
	            curl_setopt($ch, CURLOPT_HEADER, 0);
	            curl_exec($ch);
	            curl_close($ch);
	          } else {
	          	// No curl either, so fall back to fsockopen
	          	$data = '';
	          	$target = parse_url($this->page_url);
							$fp = fsockopen($target['host'], 80, $error_num, $error_str, 8); 					
							if (is_resource($fp))
							{
								fputs($fp, "GET {$this->page_url} HTTP/1.0\r\n");
								fputs($fp, "Host: {$target['host']}\r\n");
								fputs($fp, "User-Agent: EE/csvgrab PHP/" . phpversion() . "\r\n\r\n");					
							  $headers = TRUE;					
						    while( ! feof($fp)) {
						        $line = fgets($fp, 4096);				
						        if ($headers === FALSE) {
						            $data .= $line;
						        }
						        elseif (trim($line) == '') {
						            $headers = FALSE;
						        }
						    }				
						    fclose($fp);
						    fwrite( $handle, $data );						    
							}
	          }
	          // Set file pointer back to start
            fseek($handle, 0);
        } else {
        		// Using local url so we can use fopen after all
            $handle = fopen($this->page_url, "r");        
        }
    } else {
        $handle = fopen($this->page_url, "r");    
    }
    
    $entries_added = 0;

		if ( $this->trace ) {
			print "<p>TRACE: " . $handle . "</p>";
		}

		// Loop over all feed items
		while (($item = fgetcsv($handle, 10000, $this->delimiter, $this->encloser)) !== FALSE) {
        
        $row++;
        if ( $row <= $this->skip ) {
          continue;
        } else {
          $offset++;
        }

      array_unshift($item, $item[0]);

			if ( $this->trace ) {
				print "<p>TRACE: " . $row . " - ";
				print_r( $item );
				print "</p>";
			}

			$this->post = null;

			// Get title using title parameter, generate url
			$this->post[ "title" ] = $this->get_namespaced_field( 
				      					$item, 
				      					$weblog_to_feed[ 'title' ][ 'field' ] 
				      				);
			// Check for XSS
			$this->post['title'] = $REGX->xss_clean( $this->post['title'] );

			// Get unique url
			$source_encoding = ( isset( $this->RSS->source_encoding ) ? $this->RSS->source_encoding : 'UTF-8' );

			// Clean title
			if (function_exists('mb_convert_encoding'))
			{
				$encoded_title = mb_convert_encoding($this->post[ "title" ], strtoupper('UTF-8'), $source_encoding );
			}
			elseif(function_exists('iconv') AND ($iconvstr = @iconv($source_encoding, 'UTF-8', $this->post["title"])) !== FALSE)
			{
				$encoded_title = $iconvstr;
			}
			else
			{
				$encoded_title = utf8_encode($this->post["title"]);
			}

			$this->post[ "url_title" ] = $REGX->create_url_title( $encoded_title );
			$sql = "SELECT count(*) AS count FROM exp_weblog_titles WHERE url_title = '".$DB->escape_str( $this->post[ "url_title" ] )."' AND weblog_id = '$this->feed_weblog_id'";
			$results = $DB->query($sql);
			if ($results->row['count'] > 0) {
				// Duplicate exists, add a counter on the end
				$sql = "SELECT count(*) AS count FROM exp_weblog_titles WHERE url_title LIKE '".$DB->escape_str( $this->post[ "url_title" ] )."%' AND weblog_id = '$this->feed_weblog_id'";
				$results = $DB->query($sql);
				$this->post[ "url_title" ] .= $results->row['count']+1;
			}

			// Get current date
			$epoch = $LOC->now;
			
			// Use current date unless date field matches YYYY-MM-DD
			$date = $this->get_namespaced_field( 
				      					$item, 
				      					$weblog_to_feed[ 'date' ][ 'field' ] 
				      				);
			$pat = "/(\d{4})-(\d{2})-(\d{2})/";
    	if ( preg_match( $pat, $date, $match ) ) {
        list( $year, $month, $day) = array( $match[1], $match[2], $match[3]);
        $epoch = gmmktime( 0, 0, 0, $month, $day, $year);
        $epoch += $LOC->set_localized_offset();
			}
			$this->post[ "date" ] = $epoch + ( $this->stagger * ( $offset - 1 ) );

			// Load this->post array with data
			foreach ( $weblog_to_feed as $field => $data ) {
				if ( isset( $data[ "is_custom" ] ) && $data[ "is_custom" ] ) {
					$this->post[ $field ] = $this->get_namespaced_field( $item, $data[ "field" ] );
				}
			}

			if ( $this->debug ) {
				print "  Checking: " . $item[ $this->title ] . "<br />";
			}
      
			// Look for duplicate entries
			if ( $this->is_entry_unique( $this->post, $this->unique, $weblog_to_feed ) ) {
              
        if ( $this->debug ) { print "  Found new entry: " . $this->post[ "title" ] . "<br/>\n"; }

				// Get weblog details for default values
				$query = $DB->query("SELECT blog_title, blog_url, rss_url, 
															ping_return_url, deft_comments, deft_trackbacks, 
															deft_status, cat_group, field_group 
															FROM exp_weblogs 
															WHERE weblog_id = '$this->feed_weblog_id'"); 
    	
				if ($query->num_rows == 0) {
					return false;
				}

				// Insert into weblog_titles
				$data = array(  
											'entry_id'          => '',
											'weblog_id'         => $this->feed_weblog_id,
											'author_id'         => $this->author_id,
											'title'             => $this->post['title'],
											'url_title'         => $this->post['url_title'],
											'ip_address'		    => '127.0.0.1',
											'entry_date'        => ($this->post['date'] - $this->time_offset),
											'year'              => gmdate('Y', $this->post['date'] - $this->time_offset),
											'month'             => gmdate('m', $this->post['date'] - $this->time_offset),
											'day'               => gmdate('d', $this->post['date'] - $this->time_offset),
											'sticky'            => 'n',
											'status'            => $query->row['deft_status'],
											'allow_comments'    => $query->row['deft_comments'],
											'allow_trackbacks'  => $query->row['deft_trackbacks']
											);
				if ( $this->site_id != '' ) {
					$data[ 'site_id' ] = $this->site_id;
				}

				$sql = $DB->insert_string('exp_weblog_titles', $data);
				if ( $this->runsql ) {
					$DB->query($sql);
					$entry_id = $DB->insert_id;
				} else {
					$entry_id = 99999;
					if ( $this->debug ) { print $sql . "<br/>\n"; }
				}

				// Insert into weblog_data
				unset( $this->post['title'] );
				unset( $this->post['url_title'] );
				unset( $this->post['date'] );

				$data = array();
				$data["entry_id"] = $entry_id;
				$data["weblog_id"] = $this->feed_weblog_id;
				$data["entry_id"] = $entry_id;
				if ( $this->site_id != '' ) {
					$data[ 'site_id' ] = $this->site_id;
				}


				// Load custom field data into data array
				foreach ( $this->post as $custom_field => $custom_data ) {
					$data['field_id_' . $weblog_to_feed[ $custom_field ][ "id" ] ] = $REGX->xss_clean( trim( $custom_data ) );
					$data['field_ft_' . $weblog_to_feed[ $custom_field ][ "id" ] ] = $weblog_to_feed[ $custom_field ][ "format" ];
				}

				$sql = $DB->insert_string('exp_weblog_data', $data);
				if ( $this->runsql ) {
					$DB->query($sql);
				} else {
					if ( $this->debug ) { print $sql . "<br/>\n"; }
				}

				// Insert category details

				// Default category for all entries
                
				if (isset($this->cats) && $this->cats != '') 
				{         	
		        	$cats = explode(',',$this->cats);
		        	$cats = array_unique($cats);

		        	$results = $DB->query("SELECT cat_id, parent_id FROM exp_categories 
		        							WHERE (cat_id IN ('".implode("','",$cats)."') OR cat_name IN ('".implode("','",$cats)."'))
		        							AND group_id = '".$query->row['cat_group']."'");

		        	if ($results->num_rows > 0)
		        	{
		            	foreach($results->result as $row)
		            	{
		            		if ($PREFS->ini('auto_assign_cat_parents') == 'y' && $row['parent_id'] != '0')
		            		{
		            			$DB->query("INSERT INTO exp_category_posts (entry_id, cat_id) VALUES ('$entry_id', '".$row['parent_id']."')");
		            		}

		            		$DB->query("INSERT INTO exp_category_posts (entry_id, cat_id) VALUES ('$entry_id', '".$row['cat_id']."')");
		                }
		            }
		        }
		        
		// Specific category by feed field

        if ( $this->cat_field != '' ) {
        
     			$this->cat_field = str_replace(SLASH, '/', $this->cat_field);
        
					// Find category item
					$nameList = $this->get_namespaced_field( $item, $this->cat_field );

					// Does entry have multiple category items
					$num_cats = $this->get_namespaced_field( $item, $this->cat_field . "#" );
					if ( $num_cats > 1 ) {
						for( $i=2; $i<=$num_cats; $i++ ) {
							$nameList .= $this->cat_delimiter . " " . $this->get_namespaced_field( $item, $this->cat_field . "#" . $i );
						}
					}

          $cat_ids = array();

          /* From cp.mt_import.php line 1272 */

          $names = split( $this->cat_delimiter, $nameList );
          
          foreach ( $names as $name ) {
          
						$name = trim( $name );
						$query =$DB->query("SELECT cat_id
							FROM exp_categories
							WHERE exp_categories.cat_name = '".$DB->escape_str($name)."'
							AND exp_categories.parent_id = '0'
							AND exp_categories.group_id = '".$DB->escape_str($this->cat_group)."'");

						if ($query->num_rows == 0) {	
							// Create primary category
							$insert_array = array(
								'group_id'  	=> $this->cat_group,
								'site_id' => ( $this->site_id != '' ? $this->site_id : 1 ),
								'cat_name' 	=> $name,
								'cat_url_title' => $REGX->create_url_title( $name ),
								'cat_image' 	=> '',
								'parent_id'   => '0'
								);

							print "<p>Try to add category " . $name . "</p>";

							if ($this->runsql) { 
								$DB->query($DB->insert_string('exp_categories', $insert_array));       
								$cat_ids[] = $DB->insert_id;
							} else {
								print($DB->insert_string('exp_categories', $insert_array));
								$cat_ids[] = 0;
							}

							 $insert_array = array(
								'cat_id'  	=> $DB->insert_id,
								'site_id' 	=> ( $this->site_id != '' ? $this->site_id : 1 ),
								'group_id' 	=> $this->cat_group
							);
							$DB->query($DB->insert_string('exp_category_field_data', $insert_array));

						} else {
							print "<p>Category " . $name . " exists</p>";
							$cat_ids[] = $query->row['cat_id'];
						}
            
          }

          }		        
		  
		  // Insert  category details

				if ( isset($cat_ids) && count($cat_ids) > 0 ) 
				{         	
		        	$cats = array_unique($cat_ids);

		        	$results = $DB->query("SELECT cat_id, parent_id FROM exp_categories 
		        							WHERE (cat_id IN ('".implode("','",$cats)."') OR cat_name IN ('".implode("','",$cats)."'))
		        							AND group_id = '".$this->cat_group."'");

		        	if ($results->num_rows > 0)
		        	{
		            	foreach($results->result as $row)
		            	{
		            		if ($PREFS->ini('auto_assign_cat_parents') == 'y' && $row['parent_id'] != '0')
		            		{
              				if ($this->runsql) { 
		              			$DB->query("INSERT INTO exp_category_posts (entry_id, cat_id) VALUES ('$entry_id', '".$row['parent_id']."')");
		              	  }
		            		}
             				if ($this->runsql) {
		            		  $DB->query("INSERT INTO exp_category_posts (entry_id, cat_id) VALUES ('$entry_id', '".$row['cat_id']."')");
		                }
		            }
		        }

		    }
		    
		    $entries_added++;

				/* MAY USE LATER
      
				// Update member details
				$DB->query("UPDATE exp_members 
				SET total_entries = total_entries + 1, last_entry_date = '".($LOC->now + $this->entries_added - $this->time_offset)."' 
				WHERE member_id = '".$author_id."'");	

				*/
        }
			
		}
		
		fclose($handle);
		
		if ($entries_added > 0) {
		
			if ( $this->debug ) { print "<br/>New entries: " . $entries_added . "<br/>"; }

		  if ($PREFS->ini('new_posts_clear_caches') == 'y')
      {
				$FNS->clear_caching('all');
			}
			else
			{
				$FNS->clear_caching('sql_cache');
			}
		}
  }

  function usage() {
    ob_start(); 

?>
INTRO

INSTRUCTIONS

EXAMPLES

{exp:csvgrab url="http://www.url.co.uk/products.csv" 
                          weblog="5" 
                          title="0"
                          skip="6"
                          delimiter="TAB"
                          encloser=""
                          stagger="3600"
                          offset="21600"
                          use="2|5|4|12|1" 
                          fields="prod_description|prod_price|prod_url|prod_imageurl|prod_keywords" }

PARAMETERS

Required:

url - the location of the CSV feed
weblog - the id of the weblog you want to put the data into
title - the name of the field to use as the entries title
use - a pipe (|) delimited list of CSV fields to put into the entry (use column number starting from 1)
fields - a pipe delimited list of weblog fields in which to put the data

Optional:

author_id - the id of an author
category - allows feeds to be given a category by id or name, multiple comma separated values are allowed
offset - allows a time offset to be added to the publish date (sometimes useful
if the feed has the wrong time)
skip - the number of lines to skip at the start of the file
stagger - the time in seconds to leave between entries (allow entries to the staggered)
delimiter - the character that delimits fields (can also use TAB for a tab character)
encloser - the character that encloses fields

<?php

    $buffer = ob_get_contents();	
    ob_end_clean(); 
    return $buffer;
  }

	function get_namespaced_field( $item, $field ) {
		if ( isset( $item[ $field ] )) {
			return( $item[ $field ] );
		} else {
			return "";
		}
	}

	function is_entry_unique( $post, $unique, $weblog_to_feed ) {
		global $DB;

		// Default for backwards compatibility
		if ( $unique == "title" || $unique == "" ) {

			$query = $DB->query("SELECT * FROM exp_weblog_titles WHERE LEFT(title,100) = LEFT('".$DB->escape_str($post[ "title" ])."',100) AND entry_date = '".$DB->escape_str($post[ "date" ])."'");

		} else {

			/* Build custom query */
			
			$sql = "SELECT * FROM exp_weblog_titles t, exp_weblog_data d WHERE t.entry_id = d.entry_id";
			
			$uniqueArray = split(",", $unique);
			foreach ( $uniqueArray as $value ) {
				switch ( $value ) {
					case 'title': {
						$sql .= " AND " . $value . "=\"" . $DB->escape_str( $post[ $value ] ) . "\"";
						break;
					}
					case 'date': {
						$sql .= " AND entry_date=\"" . $DB->escape_str( $post[ $value ] ) . "\"";
						break;
					}
					default: {
						if ( $weblog_to_feed[ $value ][ "is_custom" ] ) {
							$name = "field_id_" . $weblog_to_feed[ $value ][ "id" ];
							$sql .= " AND " . $name . "=\"" . $DB->escape_str( $post[ $value ] ) . "\"";
						}
					}
				}
			}
			
			$query = $DB->query( $sql );
			
		}
		
		if ( $query->num_rows > 0) {
			return false;
		}
		return true;
	}

} // end class FeedGrab

?> 